import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor createProfessor(String country, int id, String name, long salary) {
    Professor emp = new Professor(country, id);
    emp.setName(name);
    emp.setSalary(salary);
    em.persist(emp);

    return emp;
  }

  public Professor findProfessor(String country, int id) {
    return (Professor) em.createQuery(
        "SELECT e FROM Professor e WHERE e.id.country = ?1 AND e.id.id = ?2")
        .setParameter(1, country).setParameter(2, id).getSingleResult();
  }

  public Collection<Professor> findAllProfessors() {
    Query query = em.createQuery("SELECT e FROM Professor e");
    return (Collection<Professor>) query.getResultList();
  }
}